import colorMethods from './colorMethods';
import addModifier from './addModifier';
import aliases from './aliases';

/**
 * Add useful methods directly to selector function, as well as put an hex() call at the end
 * @param selector
 */
var decorateSelector = function decorateSelector(selector) {
  // add member functions to our selector
  colorMethods.forEach(function (method) {
    selector[method] = function () {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return decorateSelector(addModifier.apply(undefined, [selector, method].concat(args)));
    };
  }
  // add aliases
  );Object.keys(aliases).forEach(function (method) {
    return aliases[method].forEach(function (alias) {
      return selector[alias] = function () {
        /* istanbul ignore else */
        if (process.env.NODE_ENV !== 'production' && typeof console !== 'undefined') {
          console.warn(alias + '() is deprecated. Use ' + method + '() instead.');
        }
        return selector[method].apply(selector, arguments);
      };
    });
  });
  return selector;
};

export default decorateSelector;